package com.zhentao.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zhentao.config.enums.ApiServiceExceptionEnum;
import com.zhentao.config.token.TokenUtils;
import com.zhentao.config.vo.ResultVo;
import com.zhentao.pojo.User;
import com.zhentao.pojo.dto.UserDto;
import com.zhentao.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Date 2025/5/9 12:02
 * @Author gln
 **/
@RestController
@RequestMapping("user")
public class UserController {
    @Autowired
    private UserService userService;
    @Autowired
    private RedisTemplate redisTemplate;
    @RequestMapping("login")
    public ResultVo login(@RequestBody UserDto userDto){
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("username",userDto.getUsername());
        User one = userService.getOne(queryWrapper);
        if (one!=null){
            if (one.getPassword().equals(userDto.getPassword())){
                String jwtToken = TokenUtils.createJwtToken(one.getUid());
                redisTemplate.opsForValue().set("token",jwtToken);
                return ResultVo.success(ApiServiceExceptionEnum.Login_SUCCESS);
            }else {
                return ResultVo.error(ApiServiceExceptionEnum.PASSWORD_ERROR);
            }
        }else {
            return ResultVo.error(ApiServiceExceptionEnum.USER_NOT_EXISTS);
        }
    }

}
